---
layout: post
title: Luckfox Pico Plus使用体验
tags: [开发板, 树莓派]
---

  开发板还是越小越好啊<!--more-->    

# 起因
  前段时间，银行送了我一张满50减50的淘宝不限品类优惠券，但是我一时半会没想好买什么。不知道怎么的就想起在Bilibili上看到的微型开发板Luckfox Pico系列，当时看了视频觉得挺有意思的，这次既然有机会了就可以买一个了吧……不过有这钱去买箱牛奶不好吗🤣。   
  最终买的Luckfox Pico Plus开发板，当时的价格是52CNY，加了8CNY的运费，然后用券抵完就是10CNY了。价格看上去挺不错的，不过相比之下还是不如随身WiFi便宜，那个正常买好像也才10CNY，而且整体性能也要比这个好很多，还能用WiFi联网……不过既然买了就玩玩呗，看起来也挺有意思的。   

# 使用体验
  从外观来看，整体大小只有一根食指大，因为选了带RJ45接口的板子所以其实不算特别小，而且背面甚至没有焊元件，其实它的SOC RV1103只有不到小拇指指甲盖的大小，很难不相信它其实还能做的更小。
## 安装系统
  刚买来的时候里面有预装的测试系统，不过测试系统几乎把里面的空间都占满了，肯定是不能用的，我去看了看[官方的Wiki](https://wiki.luckfox.com/zh/Luckfox-Pico/Luckfox-Pico-quick-start)，官方有提供编译好的BusyBOX、Ubuntu、buildroot以及Alpine Linux，也有可以自己编译的SDK。对我来说我也不愿意整麻烦的事情，所以肯定会选编译好的，至于系统也肯定要有软件包管理器的，另外因为这个开发板只有64MiB的内存和128MiB的存储（虽然可以插TF卡，但是内存还是没法加），系统也不能太大，所以就只有Alpine Linux可以选了。我之前[在虚拟机里测试过Alpine Linux](/2022/03/12/alpine.html)，体验还是挺不错的。   
  安装方法也很简单，[官网的Wiki](https://wiki.luckfox.com/zh/Luckfox-Pico/Luckfox-Pico-Alpine-Linux-1)有详细的说明。不过有一些不太一样的地方，我没有USB转UART串口模块，我有的只是树莓派。所以烧录完系统之后的改密码以及配置网络的过程就得用树莓派来做了，其实这体现了一下树莓派的作用，至少那堆GPIO接口不是当摆设的🤣。用法的话就是首先刷一个树莓派的官方系统到树莓派上，然后在配置里打开UART并关掉树莓派的串口登录，按官网的图接三根线，只要是导线就行，对树莓派来说应该是第8和第10脚分别是RX和TX，第6脚有一个地线，依次接到开发板上，在终端里安装screen，使用`screen /dev/serial0 115200`，就可以登录开发板的终端了，如果连接有问题可能是RX和TX接反了，反过来重新插一下就行。之后改密码以及配置网络就很简单，配置好之后连上网线就可以正常使用了。   
  不过这个系统有个缺陷，没有配置TF卡，这还是挺重要的，回头有时间可能还是得编译个能使用TF卡的Alpine Linux，或者看看官方愿不愿意编译一个？   
## 使用软件
  安装好系统之后就可以用SSH连接了。首先试了一下安装软件，Alpine Linux的软件包管理器apk用法和apt的用法差不多，而且源里的软件也非常多，安装了个Python3试了一下，没有任何问题，安装好pip之后安装python包也没有问题，这样就可以运行我用python写的一些定时任务了。另外我又下了一个[go-cqhttp](https://github.com/Mrs4s/go-cqhttp)搭了个机器人试了一下，居然也能正常运行，看来64MiB的内存还可以啊，跑些软件还是绰绰有余的，这么看来的话就可以替代掉我的树莓派了，反正我的树莓派平时除了网口其他的口都没用，运行些定时任务或者QQ机器人又觉得利用的性能太少了，而且很明显的是这个东西显然比树莓派的能耗要小的多，挂在家里挺合适的，不过缺陷可能就是如果哪天我想整个[电台](/2022/03/27/radio.html)，树莓派的GPIO接口还能派上用场，这个Luckfox Pico Plus的GPIO可能除了最开始装系统的时候用了一下，之后就再没有用了。   
  另外作为在家里装的开发板，内网穿透也是需要的，但是装了个go-cqhttp之后内存就剩下30MiB了，还要考虑定时任务运行时也要用掉一些内存，用frp肯定不太合适，但是用ssh的话又容易断，我想了一下干脆折中一下用autossh吧，如果断了也能自动重连。   

# 感想
  感觉作为开发板，Luckfox Pico Plus相比树莓派来说用途差不多，而树莓派的定位却不太准确，又想当开发板，又想当普通PC，结果作为开发板价格有点贵，尺寸有点大，功耗也有点高；作为PC性能过差，啥也干不了；作为NAS接硬盘也接不了几块，才两个USB3.0口，还要另外接供电，属实是比上不足，比下有余。这款产品我倒是觉得挺不错的，主要是颜值比较吸引我😆，其实还有和这个一样芯片的另外一个开发板，更便宜还带WiFi模块，但是相比之下还是这个好看，所以如果想整开发板我觉得Luckfox Pico Plus比树莓派更合适。