---
layout: post
title: Hackintosh使用体验
tags: [Apple, Hackintosh, macOS, 黑苹果]
---

  使用Mac到底有些什么优势呢？<!--more-->    

# 起因
  我曾经装过很多系统，Windows、FreeBSD、Linux发行版什么的都试过，但是直到我[拥有MacBook](/2023/02/03/mbp.html)我也没有试过安装黑苹果。主要是在ARM芯片的Mac出现之前，我一直看不起Mac，因为没有差异化，明明和其他电脑用的是同样的东西，一样的CPU、一样的显卡、一样的内存以及硬盘，凭什么比其他电脑贵那么多，也因此CPU能效不行，续航也不行，而且质量也不行，据说在使用蝴蝶键盘那段时间，键盘的损坏率极高，而且散热很差，经常出现CPU空焊的问题，还因此有了“梦幻单热管”的名号。   
  当然也是因为垃圾的硬件，与其配套的软件macOS也并没有什么优势，我也没什么兴趣去装黑苹果，对我来说我觉得x86时代的macOS更像是一种Linux发行版。   
  但直到ARM芯片的Mac出来之后，一切才不一样起来，差异化是一方面，在这个芯片的加持下的macOS也出现了很多的黑科技……当然这都不是重点，重点是最近正好需要一台Mac，我又不想用我自己的MacBook，所以随便找了台电脑装了个黑苹果试试效果。   

# 安装体验
  据说安装黑苹果很麻烦，不过具体麻烦在哪我也不太清楚。看了一下教程是要根据自己的电脑硬件情况自定义一个EFI文件夹用来引导，应该就是用这个方式模拟Mac的引导环境。至于怎么搞这个EFI文件夹我搜了一下，有一个叫做[RapidEFI-Tool](https://github.com/JeoJay127/RapidEFI-Tool)的软件可以填入自己电脑的硬件信息然后一键生成EFI。生成完成之后把要装macOS的硬盘的分区全部删除，然后新建ESP分区，把EFI文件放进去就行了，然后剩余的空间再创建一个分区，把苹果官方的系统镜像用[balenaEtcher](https://etcher.balena.io/)烧录到U盘里，剩下的就和正常安装系统的步骤一样了，遵循向导的提示进行就行了。   
  这么来看好像也没有很复杂，也可能是因为我用的是台式机，不用考虑无线网络之类的问题吧（当然隔空投送之类的东西就用不了了），我看其他大多数人遇到的问题好像都出在无线网络上，而且我的CPU比较老，是i5-7500，在适合装黑苹果的范围内，所以没有出现奇怪的问题，安装完成之后硬盘、显卡、内存都正确识别了，打开浏览器也能正常上网，看来是成功了。   

# 使用体验
  我装的系统和我的MacBook一样，都是macOS Sonoma 14.5，所以整体体验都是一样的，而且黑苹果的内存还更大，是16GiB的，这也能让我安心的尝试虚拟机了，不像我的笔记本才8GiB连虚拟机都不敢安。   
  绝大多数软件安装都没有问题，使用也和笔记本一样，不过如果完全一样不就体现不出我笔记本的优势了嘛🤣，我还试了试别的软件，比如针对Apple芯片优化的[llama.cpp](https://github.com/ggerganov/llama.cpp)，试了一下可以运行，但是结果全是乱码。应该是llama.cpp可以调Metal的API使用核显进行加速，但是核显好像最多只能分配2GiB的显存，而且和Apple芯片不一样的是它好像并不是可以随意分配内存给显卡的，分配给显卡的部分CPU就不能用了，而Apple芯片是两边都可以用，也正是如此，假设核显的内存够用，模型也要占两份内存，而Apple芯片的只需要占一份内存（我猜的😝）。   
  另外使用了Apple芯片的NPU的软件[Mochi Diffusion](https://github.com/MochiDiffusion/MochiDiffusion)也是不能运行的，因为根本没有做x86版本的🤣，不过用brew安装居然可以安，但是打不开🤣，所以提了个[pr](https://github.com/Homebrew/homebrew-cask/pull/176891)。不过就算做了拿Intel那个核显跑估计会卡死。   
  另外还有[PlayCover](https://github.com/PlayCover/PlayCover)也装不了，这个也算是Apple芯片的特色了，毕竟苹果不可能做ARM转x86的Rosetta，iOS的软件只可能是ARM架构的，Intel的Mac当然执行不了了。   
  还有为GPTk设计的软件[Whisky](https://github.com/Whisky-App/Whisky)也不能用，不过这个无所谓，毕竟黑苹果想切回Windows再简单不过了，根本没有安装这种软件的必要，当然如果说类似的，Crossover应该可以用，不过那个不是免费的，所以我不会去尝试它。   
  虚拟机的话我先试了一下VMware Fusion，安装是正常的，但是打不开，BIOS的虚拟化也开了，VT-d好像黑苹果不能开但应该不影响运行虚拟机。之后又试了一下UTM，我本来以为UTM是专门给Apple芯片使用的，结果居然能安装上，而且Intel版也有苹果官方的虚拟化框架，所以原生运行x86版的Ubuntu没有问题，而且系统信息显示的是Apple Virtualization Generic Platform，看来虚拟化的功能都是正常的，黑苹果效果还不错。   

# 感想
  虽然总的来看黑苹果算是不错，但是在我看来也顶多省了个Mac Mini而已，当然Mac Pro应该也能拿黑苹果代替，iMac毕竟有个质量还不错的屏幕，不能完全代替。毕竟从功能来说，我觉得macOS和Linux差不多，尤其现在Linux的软件越来越多，现在连微信都有Linux原生版了，而且还有Intel Mac没有的移动端软件（Linux可以[用容器运行Android](/2023/12/24/android.html)）。不过对于笔记本来说，续航是最大的优势，Apple芯片+macOS带来的笔记本体验才是最好的，其他Mac Mini啥的根本没有体现出Apple芯片的优势，毕竟要说性能的话同价格Mac是没有优势的，唯有续航是没有其他笔记本产品能打的（带充电宝没用，充电宝能续几个航啊）。